#include <AT91SAM7X256.h>
#include <RTL.h>
#include <stdio.h>

#include "delay.h"
#include "khan.h"
#define PORTRAIT 
#define TFTLCD_DATAPORT_B             
#define TFTLCD_DATAPORT_OFFSET      0
#define TFTLCD_CONTROLPORT_B          
#define TFTLCD_RST                  26
#define TFTLCD_CS                   27
#define TFTLCD_RS                   28
#define TFTLCD_WR                   29
#define TFTLCD_RD                   30                              

#include "tftlcd_functions.c"
#include <stdio.h>
#define left (PINA(27)==0)
#define right (PINA(30)==0)

static int x1=10,y1=300;
int x2=10,y2=280;
int x_2=-5,y_2=-5;
char j, lcd_buffer[20];
extern void init_serial (void);
__task void task_init(void);
__task void task1(void);
__task void task2(void);
__task void task_hit(void);

int main()
{

	init_serial(); 
   *AT91C_PIOA_PER=((1<<29)|(1<<27)|(1<<30));
   *AT91C_PIOA_OER=(1<<29);
   *AT91C_PIOA_ODR=((1<<27)|(1<<30));
   *AT91C_PIOA_CODR=(1<<29);

   os_sys_init(task_init);
  
}

__task void task_init(void)
{
	tftlcd_init();
	os_tsk_create(task_hit, 1);
   	os_tsk_create(task1, 1);
	os_tsk_create(task2, 1);
	os_tsk_delete_self();     
}

__task void task1(void)
{
   while(1){
		tftlcd_draw_rectangle(x1,y1,x1+70,y1+5,1,WHITE);
   		if left{
		x1=(x1-10);
		os_dly_wait(5);}
		if right{
		x1=(x1+10);
		os_dly_wait(5);}
		if(x1>=165)
		x1=165; 
		if (x1<=5) 
		x1=5;
		tftlcd_draw_rectangle(x1,y1,x1+70,y1+5,1,RED); 
		os_tsk_pass();	
   }
}

__task void task2(void)
{

   while(1){
		tftlcd_draw_circle(x2,y2,10,1,WHITE);
   		x2+=x_2;
		if(x2>234 || x2<5) x_2*=-1;
		y2+=y_2;
		if( y2<5) y_2*=-1; 
		if( y2>314 ){
		 tftlcd_clear();
		
		os_dly_wait(10);
		 tftlcd_gotoxy(10,10);
		 tftlcd_putsf("GAME OVER",RED,BLUE,0);
		 

		 *AT91C_PIOA_SODR=(1<<29);
		 os_dly_wait(500);

		 }
		tftlcd_draw_circle(x2,y2,10,1,BLUE);
		os_tsk_pass();		
   }
}

__task void task_hit(void)
{
	while(1){
		if ((y2==290)&&((x2>=x1)&&(x2<x1+70 ))) {
	
		   if right{
		   y_2=-y_2;
		   x_2=-(x_2)-3;
		   j++;
		   }
		   else	if left{
		   y_2=-(y_2);
		   x_2=-(x_2)+3;
		   j++;
		   }
		   else{
		   x_2=-x_2;
		   y_2=-y_2;
		   j++;
		   }

		   *AT91C_PIOA_SODR=(1<<29);
		   os_dly_wait(30);
		   *AT91C_PIOA_CODR=(1<<29);

		   	if (j>=10){
		    	tftlcd_gotoxy(10,10);
		        tftlcd_putsf("YOU ARE WINER",BLACK,GREEN,0);
		 			}
		    sprintf(lcd_buffer,"Hits=%u   ",j);	     
			tftlcd_gotoxy(21,17);
			tftlcd_puts(lcd_buffer,WHITE,BLACK,0);			
		
	
		os_tsk_pass();
	}
}}

